VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "colAttributes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"cAttribute"
Attribute VB_Ext_KEY = "Member0" ,"cAttribute"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private mCol As Collection
Private m_HTML As String

Public Function Add(ID As Byte, NameOf As String, Description As String, Optional sKey As String) As cAttribute
    Dim objNewMember As cAttribute
    Set objNewMember = New cAttribute
    
    objNewMember.ID = ID
    objNewMember.Description = Description
    objNewMember.NameOf = NameOf
    If sKey = "" Then sKey = CStr(ID)
    mCol.Add objNewMember, sKey
    Set Add = objNewMember
    Set objNewMember = Nothing
End Function

Public Property Get Item(vntIndexKey As Variant) As cAttribute
Attribute Item.VB_UserMemId = 0
    On Error Resume Next
    Set Item = mCol(vntIndexKey)
End Property

Public Property Get Count() As Long
    Count = mCol.Count
End Property

Public Sub Remove(vntIndexKey As Variant)
    mCol.Remove vntIndexKey
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property

Public Property Get AttrHTML() As String
   If m_HTML = "" Then CreateHTML
   AttrHTML = m_HTML
End Property

Private Sub Class_Initialize()
   Set mCol = New Collection
   Call Add(0, "ATTR INVALID", "Invalid attribute")
   Call Add(1, "Raw Read Error Rate", "Frequency of errors appearance while reading RAW data from a disk")
   Call Add(2, "Throughput Performance", "The average efficiency of hard disk")
   Call Add(3, "Spin Up Time (ms)", "Time needed by spindle to spin-up")
   Call Add(4, "Start/Stop Count", "Number of start/stop cycles of spindle")
   Call Add(5, "Reallocated Sector Count", "Quantity of remapped sectors")
   Call Add(6, "Read Channel Margin", "Reserve of channel while reading")
   Call Add(7, "Seek Error Rate", "Frequency of errors appearance while positioning")
   Call Add(8, "Seek Time Performance", "The average efficiency of operations while positioning")
   Call Add(9, "Power-On Count (hrs or min)", "Quantity of elapsed hours (or minutes) in the switched-on state")
   Call Add(10, "Spin-up Retry Count", "Number of attempts to start a spindle of a disk")
   Call Add(11, "Calibration Retry Count", "Number of attempts to calibrate a drive")
   Call Add(12, "Power Cycle Count", "Number of complete start/stop cycles of hard disk")
   Call Add(13, "Soft Read Error Rate", "Frequency of ""program"" errors appearance while reading data from a disk")
   Call Add(191, "G-Sense Error Rate", "Frequency of mistakes appearance as a result of impact loads")
   Call Add(192, "Power-Off Retract Cycle", "Number of the fixed 'turning off drive' cycles (Fujitsu: Emergency Retract Cycle Count)")
   Call Add(193, "Load/Unload Cycle Count", "Number of cycles into Landing Zone position")
   Call Add(194, "HDA Temperature (C)", "Temperature of a Hard Disk Assembly")
   Call Add(195, "Hardware ECC Recovered", "Frequency of the on the fly errors (Fujitsu: ECC On The Fly Count)")
   Call Add(196, "Reallocated Event Count", "Quantity of remapping operations")
   Call Add(197, "Current Pending Sector Count", "Current quantity of unstable sectors (waiting for remapping)")
   Call Add(198, "Off-line Scan Uncorrectable Count", "Quantity of uncorrected errors")
   Call Add(199, "UltraDMA CRC Error Rate", "Total quantity of errors CRC during UltraDMA mode")
   Call Add(200, "Write Error Rate", "Frequency of errors appearance while recording data into disk (Western Digital: Multi Zone Error Rate)")
   Call Add(201, "Soft Read Error Rate I", "Frequency of the off track errors (Maxtor: Off Track Errors)")
   Call Add(202, "Data Address Mark Errors", "Frequency of the Data Address Mark errors")
   Call Add(203, "Run Out Cancel", "Frequency of the ECC errors (Maxtor: ECC Errors)")
   Call Add(204, "Soft ECC Correction", "Quantity of errors corrected by software ECC")
   Call Add(205, "Thermal Asperity Rate", "Frequency of the thermal asperity errors")
   Call Add(206, "Flying Height", "The height of the disk heads above the disk surface")
   Call Add(207, "Spin High Current", "Quantity of used high current to spin up drive")
   Call Add(208, "Spin Buzz", "Quantity of used buzz routines to spin up drive")
   Call Add(209, "Offline Seek Performance", "Drive's seek performance during offline operations")
   Call Add(220, "Disk Shift", "Shift of disk is possible as a result of strong shock loading in the store, as a result of it's falling or for other reasons (sometimes: Temperature)")
   Call Add(221, "G-Sense Error Rate II", "This attribute is an indication of shock-sensitive sensor - total quantity of errors appearance as a result of impact loads (dropping drive, for example)")
   Call Add(222, "Loaded Hours", "Loading on drive caused by the general operating time of hours it stores")
   Call Add(223, "Load/Unload Retry Count", "Loading on drive caused by numerous recurrences of operations like: reading, recording, positioning of heads, etc.")
   Call Add(224, "Load Friction", "Loading on drive caused by friction in mechanical parts of the store")
   Call Add(225, "Load/Unload Cycle Count II", "Total of cycles of loading on drive")
   Call Add(226, "Load-in Time", "General time of loading for drive")
   Call Add(227, "Torque Amplification Count", "Quantity efforts of the rotating moment of a drive")
   Call Add(228, "Power-Off Retract Count", "Quantity of the fixed turning off's a drive")
   Call Add(230, "GMR Head Amplitude", "Amplitude of heads trembling (GMR-head) in running mode")
   Call Add(231, "Temperature II (C)", "Temperature of a drive")
   Call Add(240, "Head Flying Hours", "Time while head is positioning")
   Call Add(250, "Read Error Retry Rate", "Frequency of errors appearance while reading data from a disk")
   Call Add(PRE_FAILURE_WARRANTY, "Pre-failure warranty attribute (PW)", "Indicates a pre-failure condition (caused by exceeded threshold) where imminent loss of data is being predicted (life critical attribute).", "flag_" & PRE_FAILURE_WARRANTY)
   Call Add(ON_LINE_COLLECTION, "Online collection attribute (OC)", "Indicates that the value of this attribute is calculated during Online test.", "flag_" & ON_LINE_COLLECTION)
   Call Add(PERFORMANCE_ATTRIBUTE, "Performance attribute (PE)", "Indicates degradation of performance caused by usage or age of a drive.", "flag_" & PERFORMANCE_ATTRIBUTE)
   Call Add(ERROR_RATE_ATTRIBUTE, "Error rate attribute (ER)", "Indicates that attribute measure frequency of errors.", "flag_" & ERROR_RATE_ATTRIBUTE)
   Call Add(EVENT_COUNT_ATTRIBUTE, "Error count attribute (EC)", "Indicates that attribute is a counter of events.", "flag_" & EVENT_COUNT_ATTRIBUTE)
   Call Add(SELF_PRESERVING_ATTRIBUTE, "Self-preserving attribute (SP)", "Indicates that attribute is automatically preservable and restored each time when performing S.M.A.R.T. tests.", "flag_" & SELF_PRESERVING_ATTRIBUTE)
End Sub

Private Sub Class_Terminate()
    Set mCol = Nothing
End Sub

Private Sub CreateHTML()
   Dim i As Long
   Dim sKey As String
   Dim itm As cAttribute
   
   m_HTML = "<H1 align=center>ATTRIBUTES</H1>"
   m_HTML = m_HTML & "<P>Attributes are being used to retrieve current psychical/logical state of a drive and to show their meaning in much more readable form for end-user.</P>"
   m_HTML = m_HTML & "Each attribute can have a certain collection of flags:"
   m_HTML = m_HTML & "<BR><BR><TABLE border width=""100%"">"
   m_HTML = m_HTML & "<TR bgcolor=cyan><TH width=""25%"">Flag name</TH>"
   m_HTML = m_HTML & "<TH width=""75%"">Description</TH></TR>"
   For i = 0 To 5
       sKey = "flag_" & CStr(2 ^ i)
       m_HTML = m_HTML & "<TR><TD nowrap style=""padding-left:10""><FONT color=navy>" & colAttr(sKey).NameOf & "</FONT></TD>"
       m_HTML = m_HTML & "<TD style=""padding-left:10"">" & colAttr(sKey).Description & "</TD></TR>"
   Next i
   m_HTML = m_HTML & "</TABLE>"
   m_HTML = m_HTML & "<BR><B>Threshold</B> is the worst value for attribute. Any value lower than (or equal to) threshold means decreased performance or even hard disk failure."
   m_HTML = m_HTML & "<H2 align=center>Known attributes</H2>"
   m_HTML = m_HTML & "<TABLE border width=""100%"">"
   m_HTML = m_HTML & "<TR bgcolor=cyan><TH width=""5%"">ID</TH>"
   m_HTML = m_HTML & "<TH width=""20%"">Name of attribute</TH>"
   m_HTML = m_HTML & "<TH width=""75%"">Description</TH></TR>"
   For Each itm In colAttr
       m_HTML = m_HTML & "<TR><TD align=right>" & itm.ID & "</TD>"
       m_HTML = m_HTML & "<TD align=left nowrap style=""padding-left:10""><FONT color=navy>" & itm.NameOf & "</FONT></TD>"
       m_HTML = m_HTML & "<TD align=left style=""padding-left:10"">" & itm.Description & "</TD></TR>"
       If itm.ID = 250 Then Exit For
   Next
   m_HTML = m_HTML & "</TABLE>"
End Sub
